// #autoload
// #name = cdcmGrenHud
// #version = 1.1
// #date = October 7, 2001
// #author = Chris Gregg (adapted from Ryan Smith's Grenade HUD v0.3)
// #warrior = Fragbait
// #email = fragbait@austin.rr.com
// #web = http://home.austin.rr.com/cgregg/cdcm
// #description = Changes your inventoryHud grenade icon to reflect your loadout and allows replacement images for all hud icons
// #category = Utility
// #status = Release
// #include = support/callback.cs
// #include = support/loadout.cs
// #include = support/vehicle_callbacks.cs
// #include = support/stat_support.cs
// #readme = scripts/cdcm/cdcmGrenHud.txt

if(!isObject(cdcmGrenHud))
{
    new ScriptObject(cdcmGrenHud) {
        class = cdcmGrenHud;
	    Active = true;
    };
}

$cdcmGrenHud::pickupText["some grenades"] = "Grenade";
$cdcmGrenHud::pickupText["some flash grenades"] = "Whiteout Grenade";
$cdcmGrenHud::pickupText["some concussion grenades"] = "Concussion Grenade";
$cdcmGrenHud::pickupText["some flare grenades"] = "Flare Grenade";
$cdcmGrenHud::pickupText["a deployable camera"] = "Deployable Camera";

$cdcmGrenHud::bitMap[""] = "gui/hud_handgren";
$cdcmGrenHud::bitMap["EMPTY"] = "gui/hud_handgren";
$cdcmGrenHud::bitMap["Grenade"] = "gui/cdcm/grenFrag";
$cdcmGrenHud::bitMap["Whiteout Grenade"] = "gui/cdcm/grenFlash";
$cdcmGrenHud::bitMap["Concussion Grenade"] = "gui/cdcm/grenConc";
$cdcmGrenHud::bitMap["Flare Grenade"] = "gui/cdcm/grenFlare";
$cdcmGrenHud::bitMap["Deployable Camera"] = "gui/hud_camera";

$cdcmGrenHud::colorGuiBase = "gui/wretched/";

if(isFile("textures/" @ $cdcmGrenHud::colorGuiBase @ "hud_beacon.png")) {
    echo ("**** Loading Colored icons from textures/" @ $cdcmGrenHud::colorGuiBase @ " ****");
    $cdcmGrenHud::bitMap["Deployable Camera"] = $cdcmGrenHud::colorGuiBase @ "hud_camera";

    $cdcmGrenHud::ColorHud["gui/hud_beacon"] = $cdcmGrenHud::colorGuiBase @ "hud_beacon";
    $cdcmGrenHud::ColorHud["gui/hud_blaster"] = $cdcmGrenHud::colorGuiBase @ "hud_blaster";
    $cdcmGrenHud::ColorHud["gui/hud_camera"] = $cdcmGrenHud::colorGuiBase @ "hud_camera";
    $cdcmGrenHud::ColorHud["gui/hud_chaingun"] = $cdcmGrenHud::colorGuiBase @ "hud_chaingun";
    $cdcmGrenHud::ColorHud["gui/hud_concuss_gren"] = $cdcmGrenHud::colorGuiBase @ "hud_concuss_gren";
    $cdcmGrenHud::ColorHud["gui/hud_disc"] = $cdcmGrenHud::colorGuiBase @ "hud_disc";
    $cdcmGrenHud::ColorHud["gui/hud_elfgun"] = $cdcmGrenHud::colorGuiBase @ "hud_elfgun";
    $cdcmGrenHud::ColorHud["gui/hud_flare_gren"] = $cdcmGrenHud::colorGuiBase @ "hud_flare_gren";
    $cdcmGrenHud::ColorHud["gui/hud_grenlaunch"] = $cdcmGrenHud::colorGuiBase @ "hud_grenlaunch";
    $cdcmGrenHud::ColorHud["gui/hud_handgren"] = $cdcmGrenHud::colorGuiBase @ "hud_handgren";
    $cdcmGrenHud::ColorHud["gui/hud_medpack"] = $cdcmGrenHud::colorGuiBase @ "hud_medpack";
    $cdcmGrenHud::ColorHud["gui/hud_mine"] = $cdcmGrenHud::colorGuiBase @ "hud_mine";
    $cdcmGrenHud::ColorHud["gui/hud_missiles"] = $cdcmGrenHud::colorGuiBase @ "hud_missiles";
    $cdcmGrenHud::ColorHud["gui/hud_mortor"] = $cdcmGrenHud::colorGuiBase @ "hud_mortor";
    $cdcmGrenHud::ColorHud["gui/hud_new_packammo"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packammo";
    $cdcmGrenHud::ColorHud["gui/hud_new_packcloak"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packcloak";
    $cdcmGrenHud::ColorHud["gui/hud_new_packcloak_armed"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packcloak_armed";
    $cdcmGrenHud::ColorHud["gui/hud_new_packenergy"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packenergy";
    $cdcmGrenHud::ColorHud["gui/hud_new_packinventory"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packinventory";
    $cdcmGrenHud::ColorHud["gui/hud_new_packmotionsens"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packmotionsens";
    $cdcmGrenHud::ColorHud["gui/hud_new_packradar"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packradar";
    $cdcmGrenHud::ColorHud["gui/hud_new_packrepair"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packrepair";
    $cdcmGrenHud::ColorHud["gui/hud_new_packrepair_armed"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packrepair_armed";
    $cdcmGrenHud::ColorHud["gui/hud_new_packsatchel"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packsatchel";
    $cdcmGrenHud::ColorHud["gui/hud_new_packsensjam"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packsensjam";
    $cdcmGrenHud::ColorHud["gui/hud_new_packsensjam_armed"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packsensjam_armed";
    $cdcmGrenHud::ColorHud["gui/hud_new_packshield"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packshield";
    $cdcmGrenHud::ColorHud["gui/hud_new_packshield_armed"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packshield_armed";
    $cdcmGrenHud::ColorHud["gui/hud_new_packturret"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packturret";
    $cdcmGrenHud::ColorHud["gui/hud_new_packturretin"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packturretin";
    $cdcmGrenHud::ColorHud["gui/hud_new_packturretout"] = $cdcmGrenHud::colorGuiBase @ "hud_new_packturretout";
    $cdcmGrenHud::ColorHud["gui/hud_plasma"] = $cdcmGrenHud::colorGuiBase @ "hud_plasma";
    $cdcmGrenHud::ColorHud["gui/hud_satchel_armed"] = $cdcmGrenHud::colorGuiBase @ "hud_satchel_armed";
    $cdcmGrenHud::ColorHud["gui/hud_satchel_unarmed"] = $cdcmGrenHud::colorGuiBase @ "hud_satchel_unarmed";
    $cdcmGrenHud::ColorHud["gui/hud_shocklance"] = $cdcmGrenHud::colorGuiBase @ "hud_shocklance";
    $cdcmGrenHud::ColorHud["gui/hud_sniper"] = $cdcmGrenHud::colorGuiBase @ "hud_sniper";
    $cdcmGrenHud::ColorHud["gui/hud_targetlaser"] = $cdcmGrenHud::colorGuiBase @ "hud_targetlaser";
    $cdcmGrenHud::ColorHud["gui/hud_veh_bomb"] = $cdcmGrenHud::colorGuiBase @ "hud_veh_bomb";
    $cdcmGrenHud::ColorHud["gui/hud_whiteout_gren"] = $cdcmGrenHud::colorGuiBase @ "hud_whiteout_gren";
} else {
    echo ("**** Loading default boring icons ****");
}

function cdcmGrenHud::activate(%this)
{
	%this.Active = true;
}

function cdcmGrenHud::deactivate(%this)
{
	%this.Active = false;
}

function cdcmGrenHud::ReSpawn(%this)
{

    $cdcmGrenHud::CurrentFavName = "-- Spawn --";
    $cdcmGrenHud::CurrentFav = "armor\tScout\tWeapon\tBlaster\tWeapon\tSpinfusor\tWeapon\tChaingun\tpack\tEMPTY\tGrenade\tGrenade\tMine\tEMPTY";
    $cdcmGrenHud::CurrentFavNum = -1;
    $cdcmGrenHud::currentGren = "Grenade";
    $cdcmGrenHud::PlayerDead = 0;

    if(SiRPack.BlasterDrop == 1) {
        nextWeapon(true);
        throw(Blaster);
    }
    cdcmGrenHud.RefreshSelected();
    cdcmGrenHud.SetGrenColor();

}

function cdcmGrenHud::FavChange(%this, %index)
{
    $cdcmGrenHud::SelectedFav = $pref::Favorite[$pref::FavCurrentSelect];
    $cdcmGrenHud::SelectedFavNum = $pref::FavCurrentSelect;
    $cdcmGrenHud::SelectedFavName = $pref::FavNames[$pref::FavCurrentSelect];

    for (%i = 0; %i < getFieldCount($cdcmGrenHud::SelectedFav); %i++) {
        %type = getField($cdcmGrenHud::SelectedFav, %i);
        %equipment = getField($cdcmGrenHud::SelectedFav, %i++);

        if(%type $= "Grenade") {
            $cdcmGrenHud::SelectedGren = %equipment;
        }
    }

}

function cdcmGrenHud::QuickChange(%this, %pack, %item)
{
    if ( !isObject($Hud['inventoryScreen'].staticData[1, 1])
          || $Hud['inventoryScreen'].staticData[1, 1].getValue() $= ""  ) {
        for (%i = 0; %i < getFieldCount($cdcmGrenHud::SelectedFav); %i++) {
            %type = getField($cdcmGrenHud::SelectedFav, %i);
            %equipment = getField($cdcmGrenHud::SelectedFav, %i++);

            %invalidPack = checkPackValidity(%pack, %equipment, %item );
            if(%invalidPack) {
                return;
            }
        }
    } else {
        %armor =  $Hud['inventoryScreen'].data[0, 1].getValue();
        %invalidPack = checkPackValidity(%pack, %armor, %item );
        if(%invalidPack) {
          return;
        }

        for (%i = 1; %i < $Hud['inventoryScreen'].count; %i++) {
            %type = $Hud['inventoryScreen'].data[%i, 1].type;
            %equipment = $Hud['inventoryScreen'].data[%i, 1].getValue();
  
            if(%type $= %item) {
                %equipment = %pack;
            }
  
            %invalidPack = checkPackValidity(%pack, %equipment, %item );
            if(%invalidPack) {
                return;
            }
        }
    }

    if(%item $= "Grenade") {
        $cdcmGrenHud::SelectedGren = %pack;
    }
}


function cdcmGrenHud::InvUsed(%this)
{
    $cdcmGrenHud::CurrentFavName = $pref::FavNames[$cdcmGrenHud::SelectedFavNum];
    $cdcmGrenHud::CurrentFav = $cdcmGrenHud::SelectedFav;
    $cdcmGrenHud::CurrentFavNum = $cdcmGrenHud::SelectedFavNum;
    $cdcmGrenHud::currentGren = $cdcmGrenHud::SelectedGren;

    cdcmGrenHud.SetGrenColor();
}


function cdcmGrenHud::SetGrenColor(%this)
{
    if(isObject(inventoryHud)) {
        if(cdcmGrenHud.Active) {
            cdcmShowGrenGUI();
        }
    }

}

function cdcmGrenHud::RefreshSelected(%this)
{
    $cdcmGrenHud::SelectedFav = $pref::Favorite[$pref::FavCurrentSelect];
    $cdcmGrenHud::SelectedFavNum = $pref::FavCurrentSelect;
    $cdcmGrenHud::SelectedFavName = $pref::FavNames[$pref::FavCurrentSelect];

    for (%i = 1; %i < $Hud['inventoryScreen'].count; %i++) {
        %type = $Hud['inventoryScreen'].data[%i, 1].type;
        %equipment = $Hud['inventoryScreen'].data[%i, 1].getValue();

        if(%type $= "Grenade") {
            $cdcmGrenHud::SelectedGren = %equipment;
        }
    }
}

function cdcmGrenHudPickedUp(%Msgtype, %msgtext, %itemtext)
{
    if($cdcmGrenHud::pickupText[%itemtext] !$= "") {
        $cdcmGrenHud::currentGren = $cdcmGrenHud::pickupText[%itemtext];
        cdcmGrenHud.SetGrenColor();
    }
}

function cdcmRecolor(%obj)
{
    %bitmap = %obj.bitmap;
    %have_color = ($cdcmGrenHud::ColorHud[%bitmap] !$= "");
    if (%have_color) {
        %obj.setBitmap($cdcmGrenHud::ColorHud[%bitmap]);
    }
}

callback.add(PlayerUseInv, "cdcmGrenHud.InvUsed();");
callback.add(PlayerDeath, "cdcmHideGrenGuiOnDeath();");
addMessageCallback('MsgItemPickup', cdcmGrenHudPickedUp);

package cdcmGrenHudCallbacks
{

function toggleCursorHuds(%val)
{
    parent::toggleCursorHuds(%val);
    if(%val $= 'inventoryScreen') {
        cdcmGrenHud.RefreshSelected();
    }
}

function loadFavorite(%index, %echo)
{
    parent::loadFavorite(%index, %echo);
    cdcmGrenHud.FavChange(%index);
}

function addQuickPackFavorite(%pack, %item)
{
    parent::addQuickPackFavorite(%pack, %item);
    cdcmGrenHud.QuickChange(%pack, %item);
}

function clientCmdSetInventoryHudItem(%slot, %amount, %addItem)
{
    parent::clientCmdSetInventoryHudItem(%slot, %amount, %addItem);
    cdcmGrenHud.ReSpawn();
}

function clientCmdSetInventoryHudAmount(%slot, %amount)
{
    parent::clientCmdSetInventoryHudAmount(%slot, %amount);

    if(%slot == 0 && %amount == 0) {
        $cdcmGrenHud::currentGren = "EMPTY";
        cdcmGrenHud.SetGrenColor();
    }
}
function clientCmdSetInventoryHudClearAll()
{
    parent::clientCmdSetInventoryHudClearAll();
    cdcmHideGrenGUI();
}

function clientCmdSetInventoryHudBitmap(%slot, %name, %bitmap)
{
    %have_color = ($cdcmGrenHud::ColorHud[%bitmap] !$= "");
    if(%slot == 0) {
        %bitmap = "gui/cdcm/grenBlank";
    } else if (%have_color) {
        %bitmap = $cdcmGrenHud::ColorHud[%bitmap];
    }
    parent::clientCmdSetInventoryHudBitmap(%slot, %name, %bitmap);
}
function clientCmdSetWeaponsHudBitmap(%slot, %name, %bitmap) {
    %have_color = ($cdcmGrenHud::ColorHud[%bitmap] !$= "");
    if (%have_color) {
        %bitmap = $cdcmGrenHud::ColorHud[%bitmap];
    }
    parent::clientCmdSetWeaponsHudBitmap(%slot, %name, %bitmap);
}

function clientCmdSetBackpackHudItem(%num, %addItem) {
    parent::clientCmdSetBackpackHudItem(%num, %addItem);
    if(%addItem) {
        cdcmRecolor(backpackIcon);
    }
}

function ClientCmdDisplayHuds() {
	parent::ClientCmdDisplayHuds();

	  switch$ ($HudMode) {
	    case "Pilot":
	      cdcmHideGrenGUI();
	    case "Passenger":
	      cdcmShowGrenGUI();
	    case "Object":
	      cdcmHideGrenGUI();
	    case "Observer":
	      cdcmHideGrenGUI();
	    case "PickTeam":
	      cdcmHideGrenGUI();
        case "Standard":
          cdcmShowGrenGUI();
	    default:
	      cdcmHideGrenGUI();
	  }
}

function clientCmdSetSatchelArmed()
{
    parent::clientCmdSetSatchelArmed();
    cdcmRecolor(backpackIcon);
}

function clientCmdsetCloakIconOn()
{
    parent::clientCmdsetCloakIconOn();
    cdcmRecolor(backpackIcon);
}

function clientCmdsetCloakIconOff()
{
    parent::clientCmdsetCloakIconOff();
    cdcmRecolor(backpackIcon);
}

function clientCmdsetRepairPackIconOn()
{
    parent::clientCmdsetRepairPackIconOn();
    cdcmRecolor(backpackIcon);
}

function clientCmdsetRepairPackIconOff()
{
    parent::clientCmdsetRepairPackIconOff();
    cdcmRecolor(backpackIcon);
}

function clientCmdsetShieldIconOn()
{
    parent::clientCmdsetShieldIconOn();
    cdcmRecolor(backpackIcon);
}

function clientCmdsetShieldIconOff()
{
    parent::clientCmdsetShieldIconOff();
    cdcmRecolor(backpackIcon);
}

function clientCmdsetSenJamIconOn()
{
    parent::clientCmdsetSenJamIconOn();
    cdcmRecolor(backpackIcon);
}

function clientCmdsetSenJamIconOff()
{
    parent::clientCmdsetSenJamIconOff();
    cdcmRecolor(backpackIcon);
}

function clientCmdShowVehicleGauges(%vehType, %node)
{
    parent::clientCmdShowVehicleGauges(%vehType, %node);
    switch$ (%vehType) {
        case "Shrike" :
            cdcmRecolor(vWeapIconOne);
        case "Bomber" :
            if (%node == 1) {
                cdcmRecolor(vWeaponOne);
                cdcmRecolor(vWeaponTwo);
                cdcmRecolor(vWeaponThree);
            }
        case "Assault" :
            if(%node == 1) {
                cdcmRecolor(vWeaponOne);
                cdcmRecolor(vWeaponTwo);
            }
    }
}

function cdcmShowGrenGUI(){
    if (!$cdcmGrenHud::PlayerDead) {
        cdcmGrenIcon.setBitmap($cdcmGrenHud::bitMap[$cdcmGrenHud::currentGren]);
        %xpos = firstWord(inventoryHud.position) + 1;
        %ypos = getWord(inventoryHud.position, 1) + 1;
        cdcmGrenIcon.position = %xpos SPC %ypos;
        cdcmGrenIcon.setVisible(1);
    }
}

function cdcmHideGrenGuiOnDeath() {
    $cdcmGrenHud::PlayerDead = 1;
}

function cdcmHideGrenGUI(){
    cdcmGrenIcon.setVisible(0);
}

function cdcmGetGrenType() {
    return $cdcmGrenHud::currentGren;
}

function PlayGui::onWake(%this) {
    parent::onWake(%this);

    if(!isObject(PlayGui)) {
        return;
    }

    if(isObject(cdcmGrenIcon)) {
        return;
    }

    %xpos = 0;
    %ypos = 0;

    new GuiBitmapCtrl(cdcmGrenIcon) {
        profile = "GuiDefaultProfile";
        visible = "0";
        extent = "25 25";
        opacity = "1";
        position = %xpos SPC %ypos;
        bitmap = "gui/hud_handgren";
    };
    PlayGui.add(cdcmGrenIcon);
}

};

activatePackage(cdcmGrenHudCallbacks);

